#include <unistd.h>
#include <string.h>
#include "fonts.h"

extern volatile unsigned short *gp2x_memregs;

unsigned int gp2x_joystick_read(void)
{
	static unsigned int value_old = 0, timeouts = 0;
	unsigned int value = 0, i, to;

	to = 8 - timeouts/2;
	for (i = 0; i < to; i++)
	{
		value = (gp2x_memregs[0x1198>>1] & 0x00FF);
		value = ~((gp2x_memregs[0x1184>>1] & 0xFF00) | value | (gp2x_memregs[0x1186>>1] << 16));
		if (value != value_old) { timeouts = 0; break; }
		usleep(1000); // will really do something like 30000..
	}
	if (i == to) timeouts++;
	if (timeouts > 7*2) timeouts = 7*2;

	value_old = value;

	return value;
}


void gp2x_video_wait_vsync(void)
{
	unsigned short v = gp2x_memregs[0x1182>>1];
	while (!((v ^ gp2x_memregs[0x1182>>1]) & 0x10))
	{
		volatile int i;
		for (i = 0; i < 1000; i++);
	}
}


#define SCREEN_WIDTH 320
#define COLOR        1

void text_out8(unsigned char *dst, int x, int y, const char *text)
{
	int i,l,len=strlen(text);
	unsigned char *screen = dst + x + y*SCREEN_WIDTH;

	for (i = 0; i < len; i++)
	{
		for (l=0;l<8;l++)
		{
			unsigned char fd = fontdata8x8[((text[i])*8)+l];
			if (fd&0x80) screen[l*SCREEN_WIDTH+0]=COLOR;
			if (fd&0x40) screen[l*SCREEN_WIDTH+1]=COLOR;
			if (fd&0x20) screen[l*SCREEN_WIDTH+2]=COLOR;
			if (fd&0x10) screen[l*SCREEN_WIDTH+3]=COLOR;
			if (fd&0x08) screen[l*SCREEN_WIDTH+4]=COLOR;
			if (fd&0x04) screen[l*SCREEN_WIDTH+5]=COLOR;
			if (fd&0x02) screen[l*SCREEN_WIDTH+6]=COLOR;
			if (fd&0x01) screen[l*SCREEN_WIDTH+7]=COLOR;
		}
		screen += 8;
	}
}


